#!/bin/bash
#La opción 1 es la interfaz, la opción 2 es el archivo para guardar las reglas
#La opción 2 es:
#en caso de lihuen /var/lib/iptables/active
#en caso de debian /etc/firewall.conf
INTERFACE="$1"
IPTABLES="/sbin/iptables"
IPTABLES_SAVE="/sbin/iptables-save"
IPTABLES_ARRANQUE="$2"

stop_firestarter(){
	# Si firestarter está ejecutandose se lo desactivará y se mostrará una advertencia
	if [ -e /var/lock/subsys/firestarter -o -e /var/lock/firestarter ]; then
		invoke-rc.d firestarter stop		
	fi
}

stop_firestarter
if [ -x $IPTABLES ]; then
	if [ -x /etc/init.d/iptables ] && [ -f $2 ]; then	
		#Reiniciamos iptables (queremos modificar esta configuración, la del firestarter por el momento no la modificaremos)
		invoke-rc.d iptables restart
	else
		if [ $2 == "/etc/firewall.conf" ]; then
			echo "#!/bin/sh" >  /etc/network/if-up.d/iptables
			echo "iptables-restore < $2" >> /etc/network/if-up.d/iptables 			
			chmod +x /etc/network/if-up.d/iptables 
		fi
	fi		
	# Borramos todas las posibles ocurrencias de la regla si ya existía
	while $IPTABLES -D INPUT -i "$INTERFACE" -j ACCEPT; do
		tmp=0 # sólo para evitar un  error de sintaxis
	done
	# Insertamos la regla al principio de la chain Input
	$IPTABLES -I INPUT -i "$INTERFACE" -j ACCEPT
	$IPTABLES_SAVE > $2
	exit 0
fi
exit 1
